#!/usr/bin/perl
# 
# test script for Serene Bach libraries
# == written by T.Otani <ootani@segausers.gr.jp> ===
# == Copyright (C) 2004 SimpleBoxes/SerendipityNZ ==

# ======================================
use strict;
use warnings;
use lib qw(./ ../);
use sb::Test;
sb::Test::NetPing->run();

package sb::Test::NetPing;
use vars qw( $VERSION );
$VERSION = '0.00';
# 0.00 [2007/11/29] created
# --------------------------------------
# // public functions
sub run
{
	my $testcase = sb::Test->new();
	$testcase->add('netping - discover_tb',\&_discover_tb_test,\&_discover_tb_check);
	$testcase->add('netping - send_update',\&_send_update_test,\&_send_update_check);
	$testcase->run();
}
# --------------------------------------
# // private functions
sub _discover_tb_test
{
	require sb::Net::Ping;
	my $ping = sb::Net::Ping->new();
	my @urls = $ping->discover_trackback('http://serennz.sakura.ne.jp/sb/log/eid75.html');
	return \@urls if (!$ping->error);
	return [''];
}
sub _discover_tb_check
{
	my $result = shift;
	return if (!$result or ref($result) ne 'ARRAY');
	return if ($result->[0] ne 'http://serennz.sakura.ne.jp/sb/sb.cgi/75');
	return 1;
}
sub _send_update_test
{
	require sb::Net::Ping;
	my $ping = sb::Net::Ping->new();
	return $ping->send_update(
		'list' => ['http://serennz.sakura.ne.jp/sblog/rep.cgi'],
		'mode' => 'debug',
		'name' => 'my first weblog',
		'url'  => 'http://127.0.0.1/sb/',
		'code' => 'utf8',
	);
}
sub _send_update_check
{
	my $result = shift;
	return if (!$result or ref($result) ne 'HASH');
	return if ($result->{'sent'}->[0] ne 'http://serennz.sakura.ne.jp/sblog/rep.cgi');
	return 1;
}
